import bpy

class MspGLProperties(bpy.types.Panel):
	bl_idname = "OBJECT_PT_mspgl_properties"
	bl_label = "MspGL properties"
	bl_space_type = "PROPERTIES"
	bl_region_type = "WINDOW"
	bl_context = "object"

	def draw(self, context):
		obj = context.active_object

		self.layout.prop(obj, "technique");
		self.layout.prop(obj, "inherit_tech");
		self.layout.prop(obj, "compound");

def register_properties():
	bpy.types.Object.technique = bpy.props.StringProperty(name="Technique", description="Name of the technique to use for rendering")
	bpy.types.Object.inherit_tech = bpy.props.BoolProperty(name="Inherit technique", description="Inherit from the technique to customize textures")
	bpy.types.Object.compound = bpy.props.BoolProperty(name="Compound with parent", description="Join this object to its parent when exporting")
