#ifndef MSP_GL_LIGHTUNIT_H_
#define MSP_GL_LIGHTUNIT_H_

#include <vector>

namespace Msp {
namespace GL {

class Light;

class LightUnit
{
private:
	unsigned index;
	const Light *light;

	static std::vector<LightUnit> units;
	static LightUnit *cur_unit;

	LightUnit();

public:
	unsigned get_index() const { return index; }
	bool set_light(const Light *);
	const Light *get_light() const { return light; }

	static unsigned get_n_units();
	static LightUnit &get_unit(unsigned i);
	static LightUnit *find_unit(const Light *);
};

} // namespace GL
} // namespace Msp

#endif
