#ifndef MSP_GL_RESOURCE_H_
#define MSP_GL_RESOURCE_H_

#include <msp/core/inttypes.h>
#include <msp/io/seekable.h>

namespace Msp {
namespace GL {

class ResourceManager;

class Resource
{
public:
	class AsyncLoader
	{
	protected:
		AsyncLoader() { }
	public:
		virtual ~AsyncLoader() { }

		virtual bool needs_sync() const = 0;
		virtual bool process() = 0;
	};

protected:
	ResourceManager *manager;
	void *manager_data;

	Resource();
public:
	virtual ~Resource();

	void set_manager(ResourceManager *);
	ResourceManager *get_manager() const { return manager; }
	void *get_manager_data() const { return manager_data; }
	virtual AsyncLoader *load(IO::Seekable &) = 0;
	virtual UInt64 get_data_size() const = 0;
	virtual void unload() = 0;
};

} // namespace GL
} // namespace Msp

#endif
