#include "renderer.h"
#include "simplescene.h"

namespace Msp {
namespace GL {

void SimpleScene::add(const Renderable &r)
{
	renderables.insert(&r);
}

void SimpleScene::remove(const Renderable &r)
{
	renderables.erase(&r);
}

void SimpleScene::setup_frame() const
{
	for(RenderableSet::const_iterator i=renderables.begin(); i!=renderables.end(); ++i)
		(*i)->setup_frame();
}

void SimpleScene::finish_frame() const
{
	for(RenderableSet::const_iterator i=renderables.begin(); i!=renderables.end(); ++i)
		(*i)->finish_frame();
}

void SimpleScene::render(Renderer &renderer, const Tag &tag) const
{
	setup_cullers(renderer);
	for(RenderableSet::const_iterator i=renderables.begin(); i!=renderables.end(); ++i)
		if(!cull(renderer, **i))
			renderer.render(**i, tag);
}

} // namespace GL
} // namespace Msp
