#ifndef MSP_GL_SIMPLESCENE_H_
#define MSP_GL_SIMPLESCENE_H_

#include <set>
#include "scene.h"

namespace Msp {
namespace GL {

/**
The simplest possible Scene.  Rendering order is unspecified.
*/
class SimpleScene: public Scene
{
protected:
	typedef std::set<const Renderable *> RenderableSet;

	RenderableSet renderables;

public:
	virtual void add(const Renderable &);
	virtual void remove(const Renderable &);

	virtual void setup_frame() const;
	virtual void finish_frame() const;

	using Scene::render;
	virtual void render(Renderer &, const Tag & = Tag()) const;
};

} // namespace GL
} // namespace Msp

#endif
