#ifndef MSP_GL_TEXTURE1D_H_
#define MSP_GL_TEXTURE1D_H_

#include "datatype.h"
#include "pixelformat.h"
#include "texture.h"

namespace Msp {
namespace GL {

class Texture1D: public Texture
{
private:
	PixelFormat ifmt;
	unsigned width;
	unsigned allocated;

public:
	Texture1D();

	void storage(PixelFormat, unsigned);
	void allocate(unsigned);
	void image(unsigned, PixelFormat, DataType, const void *);
	unsigned get_width() const { return width; }

private:
	unsigned get_level_size(unsigned);

public:
	virtual AsyncLoader *load(IO::Seekable &) { return 0; }
	virtual UInt64 get_data_size() const;
	virtual void unload() { }
};

} // namespace GL
} // namespace Msp

#endif
