#ifndef MSP_GL_TEXTURING_H_
#define MSP_GL_TEXTURING_H_

#include <vector>
#include "bindable.h"

namespace Msp {
namespace GL {

class Texture;

class Texturing: public Bindable<Texturing>
{
private:
	struct Attachment
	{
		const Texture *tex;

		Attachment();
	};

	std::vector<Attachment> attachments;

public:
	~Texturing();

	void attach(unsigned, const Texture &);
	void detach(unsigned);
private:
	void set_attachment(unsigned, const Texture *);
	void bind_attachment(unsigned) const;

	static void unbind_attachment(unsigned);

public:
	void bind() const;

	static void unbind();
};

} // namespace GL
} // namespace Msp;

#endif
